<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <!-- Now include the data synchronizer services -->
  <xsl:template name="includeDataSyncServices">
      <bean id="baseDataSyncService"
        class="com.invoqsystems.apex.datasynchronizer.services">
        <property name="auditSyncService" ref="auditSyncService"/>
      </bean>

      <bean id="dataSyncAccessService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncAccessServiceImpl"
        parent="baseDataSyncService">
        <property name="accessService" ref="filteredAccessService" />
      </bean>
      
      <bean id="dataSyncLanguageService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncLanguageServiceImpl"
        parent="baseDataSyncService">
        <property name="organizationService" ref="filteredOrganizationService" />
      </bean>

      <bean id="dataSyncTimeZoneService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncTimeZoneServiceImpl"
        parent="baseDataSyncService">
        <property name="organizationService" ref="filteredOrganizationService" />
      </bean>

      <bean id="dataSyncPersonService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncPersonServiceImpl"
        parent="baseDataSyncService">
        <property name="personService" ref="filteredPersonService" />
        <property name="organizationService" ref="filteredOrganizationService" />
      </bean>

      <bean id="dataSyncGroupService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncGroupServiceImpl"
        parent="baseDataSyncService">
        <property name="groupService" ref="filteredGroupService" />
        <property name="organizationService" ref="filteredOrganizationService" />
      </bean>
    
      <bean id="dataSyncDeviceTimeframeService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncDeviceTimeframeServiceImpl"
        parent="baseDataSyncService">
        <property name="groupService" ref="filteredGroupService" />
        <property name="deviceService" ref="filteredDeviceService" />
      </bean>

      <bean id="dataSyncTeamService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncTeamServiceImpl"
        parent="baseDataSyncService">
        <property name="teamService" ref="filteredTeamService" />
        <property name="organizationService" ref="filteredOrganizationService" />
      </bean>

      <bean id="dataSyncTeamMembershipService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncTeamMembershipServiceImpl"
        parent="baseDataSyncService">
        <property name="groupService" ref="filteredGroupService" />
        <property name="teamService" ref="filteredTeamService" />
        <property name="personService" ref="filteredPersonService" />
        <property name="deviceService" ref="filteredDeviceService" />
      </bean>

      <bean id="dataSyncSiteService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncSiteServiceImpl"
        parent="baseDataSyncService">
        <property name="siteService" ref="filteredSiteService" />
        <property name="organizationService" ref="filteredOrganizationService" />
        <property name="personService" ref="filteredPersonService" />
      </bean>

      <bean id="dataSyncServiceProviderService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncServiceProviderServiceImpl"
        parent="baseDataSyncService">
        <property name="serviceProviderService" ref="filteredServiceProviderService" />
      </bean>

      <bean id="dataSyncEmailService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncEmailServiceImpl"
        parent="baseDataSyncService">
        <property name="deviceService" ref="filteredDeviceService" />
      </bean>

      <bean id="dataSyncIMService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncIMServiceImpl"
        parent="baseDataSyncService">
        <property name="deviceService" ref="filteredDeviceService" />
      </bean>

      <bean id="dataSyncTextPagerService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncTextPagerServiceImpl"
        parent="baseDataSyncService">
        <property name="deviceService" ref="filteredDeviceService" />
      </bean>

      <bean id="dataSyncNumericPagerService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncNumericPagerServiceImpl"
        parent="baseDataSyncService">
        <property name="deviceService" ref="filteredDeviceService" />
      </bean>

      <bean id="dataSyncVoiceService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncVoiceServiceImpl"
        parent="baseDataSyncService">
        <property name="deviceService" ref="filteredDeviceService" />
      </bean>

      <bean id="dataSyncTextPhoneService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncTextPhoneServiceImpl"
        parent="baseDataSyncService">
        <property name="deviceService" ref="filteredDeviceService" />
      </bean>

      <bean id="dataSyncGenericDeviceService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncGenericDeviceServiceImpl"
        parent="baseDataSyncService">
        <property name="deviceService" ref="filteredDeviceService" />
      </bean>

      <bean id="dataSyncBESDeviceService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncBESDeviceServiceImpl"
        parent="baseDataSyncService">
        <property name="deviceService" ref="filteredDeviceService" />
      </bean>

      <bean id="dataSyncDeviceNameService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncDeviceNameServiceImpl"
        parent="baseDataSyncService">
        <property name="organizationService" ref="filteredOrganizationService" />
      </bean>
      
      <bean id="dataSyncClusterService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncClusterServiceImpl"
        parent="baseDataSyncService">
        <property name="organizationService" ref="filteredOrganizationService" />
      </bean>
      
      <bean id="dataSyncCountryService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncCountryServiceImpl"
        parent="baseDataSyncService">
        <property name="organizationService" ref="filteredOrganizationService" />
      </bean>

      <bean id="dataSyncCustomAttributeCategoryService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncCustomAttributeCategoryServiceImpl"
        parent="baseDataSyncService">
        <property name="customService" ref="filteredCustomService"/>
        <property name="organizationService" ref="filteredOrganizationService" />
      </bean>     

      <bean id="dataSyncCustomAttributeService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncCustomAttributeServiceImpl"
        parent="baseDataSyncService">
        <property name="customService" ref="filteredCustomService"/>
        <property name="organizationService" ref="filteredOrganizationService" />
      </bean>
      
      <bean id="dataSyncCustomFieldService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncCustomFieldServiceImpl"
        parent="baseDataSyncService">
        <property name="customService" ref="filteredCustomService"/>
        <property name="organizationService" ref="filteredOrganizationService" />
      </bean>

      <bean id="dataSyncGroupRecurringScheduleService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncGroupRecurringScheduleServiceImpl"
        parent="baseDataSyncService">
        <property name="groupService" ref="filteredGroupService"/>
      </bean>

      <bean id="dataSyncGroupHolidayScheduleService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncGroupHolidayScheduleServiceImpl"
        parent="baseDataSyncService">
        <property name="groupService" ref="filteredGroupService"/>
      </bean>

      <bean id="transactionalDataSyncCustomValueService" parent="baseTransactionProxy">
        <property name="proxyInterfaces">
          <value>com.invoqsystems.apex.datasynchronizer.services.DataSyncCustomValueService</value>
        </property>
        <property name="target" ref="dataSyncCustomValueService"/>
    		<property name="transactionAttributes">
    			<props>
    				<prop key="saveOrUpdate*">PROPAGATION_REQUIRED</prop>
    			</props>
    		</property>
      </bean>

      <bean id="dataSyncCustomValueService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncCustomValueServiceImpl"
        parent="baseDataSyncService">
				<property name="dataSyncPersonService">
					<ref bean="dataSyncPersonService"/>
				</property>
				<property name="dataSyncCustomFieldService">
					<ref bean="dataSyncCustomFieldService"/>
				</property>
        <property name="personService" ref="filteredPersonService"/>
        <property name="organizationService" ref="filteredOrganizationService"/>
        <property name="customService" ref="filteredCustomService" />
      </bean>

      <bean id="dataSyncEventDomainPredicateService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncEventDomainPredicateServiceImpl"
        parent="baseDataSyncService">
        <property name="subscriptionService" ref="filteredSubscriptionService"/>
        <property name="messageDomainService" ref="filteredMessageDomainService"/>
      </bean>

      <bean id="dataSyncEventDomainService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncEventDomainServiceImpl"
        parent="baseDataSyncService">
        <property name="subscriptionService" ref="filteredSubscriptionService"/>
        <property name="organizationService" ref="filteredOrganizationService"/>
      </bean>

      <bean id="dataSyncLDAPDomainService"
        class="com.invoqsystems.apex.datasynchronizer.services.DataSyncLDAPDomainServiceImpl"
        parent="baseDataSyncService">
        <property name="organizationService" ref="filteredOrganizationService"/>
      </bean>

      <bean id="auditSyncService"
        class="com.invoqsystems.apex.datasynchronizer.services.AuditSyncService">
        <property name="auditService" ref="transactionalAuditService"/>
      </bean>

    </xsl:template>
</xsl:stylesheet>
